package com.qgs.dc.s7.controller;

import com.qgs.dc.opcua.controller.R;
import com.qgs.dc.s7.my.s7connector.api.DaveArea;
import com.qgs.dc.s7.my.s7connector.api.S7Connector;
import com.qgs.dc.s7.my.s7connector.api.utils.ByteUtils;
import com.qgs.dc.s7.my.s7connector.enmuc.PlcVarActual;
import com.qgs.dc.s7.my.s7connector.enmuc.S7Client;

import com.qgs.dc.s7.my.s7connector.service.S7Service;
import org.apache.plc4x.java.api.exceptions.PlcConnectionException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.io.UnsupportedEncodingException;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.List;

@RestController
@RequestMapping("/s7")
public class S7Controller {
    private static final Logger logger = LoggerFactory.getLogger(S7Controller.class);

    @Autowired
    S7Service s7Service;

    //demo1
    @PostMapping("/testReadAll")
    public R testReadAll() throws UnsupportedEncodingException, ParseException {
        for(PlcVarActual actual:PlcVarActual.values()){
            System.out.println(s7Service.read(actual,S7Client.S7_1200));;
        }
        return R.ok();
    }

    //demo2
    @PostMapping("/readTest")
    public R getTestForS7() throws UnsupportedEncodingException, ParseException {
        Boolean heartBeat = (Boolean)s7Service.read(PlcVarActual.HeartBeat,S7Client.S7_1200);
        String ddtl = (String)s7Service.read(PlcVarActual.DTL,S7Client.S7_1200);
        List<Character> characters = (List<Character>)s7Service.read(PlcVarActual.CharArrays,S7Client.S7_1200);

        List<Boolean> booleans = (List<Boolean>)s7Service.read(PlcVarActual.BooleanArrays,S7Client.S7_1200);
        String stri = (String)s7Service.read(PlcVarActual.STRING1,S7Client.S7_1200);

        return R.ok().put("res",heartBeat).put("characters",characters).put("ddtl",ddtl).put("bools",booleans).put("str",stri);
    }

    //demo3
    @PostMapping("/writeTest")
    public R writeTest() throws PlcConnectionException, UnsupportedEncodingException {
        s7Service.write(PlcVarActual.HeartBeat, false, S7Client.S7_1200);

        char[] charArrays_content = new char[2];
        charArrays_content[0] = '1';
        charArrays_content[1] = 'c';
        s7Service.write(PlcVarActual.CharArrays, charArrays_content, S7Client.S7_1200);

        boolean[] boolArrays_content = new boolean[2];
        boolArrays_content[0] = true;
        boolArrays_content[1] = false;
        s7Service.write(PlcVarActual.BooleanArrays, boolArrays_content, S7Client.S7_1200);

        String str = "你好啊aa";
        //todo string 的读写有问题 待会看看
        s7Service.write(PlcVarActual.STRING1, str, S7Client.S7_1200);
        return R.ok().put("res",true);
    }

}
