package com.qgs.dc.s7.my.s7connector;

import cn.hutool.core.util.ByteUtil;

import java.math.BigInteger;
import java.util.Stack;

/**
 * @Desc: ""
 * @Author: caixiang
 * @DATE: 2021/12/10 11:22
 */
public class Main2 {
    public static byte[] double2Bytes(double d) {
        long value = Double.doubleToRawLongBits(d);
        byte[] byteRet = new byte[8];
        for (int i = 0; i < 8; i++) {
            byteRet[i] = (byte) ((value >> 8 * i) & 0xff);
        }
        return byteRet;
    }
    /**
     * 1个字节byte[] 转成有符号的short
     * */
    public static Integer toInt(byte bytes) {
        return Integer.valueOf(Byte.toString(bytes));
    }
    public static Integer toUInt(byte bytes) {
        return Integer.valueOf(Byte.toUnsignedInt(bytes));
    }

    public static void main(String[] args) {


        byte[] bytes = new byte[2];
        bytes[0] = -1; //内部是 补码形式存在  //todo 搞清楚 补码和原码什么时候转化
        bytes[1] = -111;
        //-1 原码 1000 0001 ；；-1 补码 1111 1111
        //1000 0001  1110 1111  //原码形式
        //1111 1111  1001 0001  //补码形式，在计算机内部是以补码形式存储的，当赋值给2个字节后是无符号整形的 要强制转化成short类型后,如果之前首位是1 就会被java强制转化成补码
        //1000 0000  0110 1111  //
        //1+16+128+256+512+1024+2048+4096+4096*2+4096*3+4096*4
        //1024*(63)

        //1000 0000  0110 1111  //-111
        System.out.println(toInt(bytes[0]));
        System.out.println(toUInt(bytes[0]));
        System.out.println(toInt(bytes[1]));
        System.out.println(toUInt(bytes[1]));

        System.out.println("无符号 "+(bytes[1] & 0xff | (bytes[0] & 0xff) << Byte.SIZE));
        System.out.println("有符号 "+(short)(bytes[1] & 0xff | (bytes[0] & 0xff) << Byte.SIZE));

//        //byte类型的数字要&0xff再赋值给int类型，其本质原因就是想保持二进制补码的一致性。  0xff 其实就是0000 0000 0000 0000 0000 0000 1111 0100
        short l = 0;
        l<<=8; //<<=和我们的 +=是一样的，意思就是 l = l << 8
        //注意： 移位并不会增加原来字节长度，被挤掉的数据就没了，而且是以补码的形式移动的。
        l |= (bytes[0] & 0xff); //和上面也是一样的  l = l | (b[i]&0xff)    // 255  补码 1111 1111

        l<<=7;
        l<<=1;
        //l<<=8; //<<=和我们的 +=是一样的，意思就是 l = l << 8
        l |= (bytes[1] & 0xff); //和上面也是一样的  l = l | (b[i]&0xff)


        short c = 0;
        c<<=8; //<<=和我们的 +=是一样的，意思就是 l = l << 8
        //注意： 移位并不会增加原来字节长度，被挤掉的数据就没了，而且是以补码的形式移动的。
        c |= ((byte)1 & 0xff); //和上面也是一样的  l = l | (b[i]&0xff)    // 255  补码 1111 1111

        c<<=7;
        c<<=1;
        //l<<=8; //<<=和我们的 +=是一样的，意思就是 l = l << 8
        c |= ((byte)2 & 0xff); //和上面也是一样的  l = l | (b[i]&0xff)


        byte bb = -1;
        bb<<=8;
        System.out.println(bb);
        System.out.println(l);
        System.out.println(Byte.valueOf((byte) 0x81));  //有符号  因为0x81 会自动被java 转成byte，而byte会以补码 有符号的形式存在
        System.out.println(0x81);                       //无符号


        byte[] lrealBuffer = new byte[8];
        Number lrealNumber = new Double(-12.1);
        byte[] bytesss = ByteUtil.numberToBytes(lrealNumber);
        Number intNumber = new Integer(-12);
        byte[] bytessss = ByteUtil.numberToBytes(intNumber);

        Integer s = new Integer(-999);
        byte b = s.byteValue();
        System.out.println();
    }

    public static double bytes2Double(byte[] arr) {
        long value = 0;
        for (int i = 0; i < 8; i++) {
            value |= ((long) (arr[i] & 0xff)) << (8 * i);
        }
        return Double.longBitsToDouble(value);
    }

    public static byte[] short2byte(short s){
        byte[] b = new byte[2];
        for(int i = 0; i < 2; i++){
            int offset = 16 - (i+1)*8; //因为byte占4个字节，所以要计算偏移量
            b[i] = (byte)((s >> offset)&0xff); //把16位分为2个8位进行分别存储
        }
        return b;
    }
    /**
     * 将byte[]转为各种进制的字符串
     * @param bytes byte[]
     * @param radix 基数可以转换进制的范围，从Character.MIN_RADIX到Character.MAX_RADIX，超出范围后变为10进制
     * @return 转换后的字符串
     */
    public static String binary(byte[] bytes, int radix){
        return new BigInteger(1, bytes).toString(radix);// 这里的1代表正数
    }

    public static String byteToBit(byte b) {
        return ""
                + (byte) ((b >> 7) & 0x1) + (byte) ((b >> 6) & 0x1)
                + (byte) ((b >> 5) & 0x1) + (byte) ((b >> 4) & 0x1) +","
                + (byte) ((b >> 3) & 0x1) + (byte) ((b >> 2) & 0x1)
                + (byte) ((b >> 1) & 0x1) + (byte) ((b >> 0) & 0x1);
    }

    public static short byte2short(byte[] b){
        short l = 0;
        for (int i = 0; i < 2; i++) {
            l<<=8; //<<=和我们的 +=是一样的，意思就是 l = l << 8
            l |= (b[i] & 0xff); //和上面也是一样的  l = l | (b[i]&0xff)
        }
        return l;
    }

    public static byte[] int2byte(int s){
        byte[] b = new byte[2];
        for(int i = 0; i < 4; i++){
            int offset = 16 - (i+1)*8; //因为byte占4个字节，所以要计算偏移量
            b[i] = (byte)((s >> offset)&0xff); //把32位分为4个8位进行分别存储
        }
        return b;
    }


    public static int byte2int(byte[] b){
        int l = 0;
        for (int i = 0; i < 4; i++) {
            l<<=8; //<<=和我们的 +=是一样的，意思就是 l = l << 8
            l |= (b[i] & 0xff); //和上面也是一样的  l = l | (b[i]&0xff)
        }
        return l;
    }



    /**
     * int到byte[](byte数组4个字节)
     * @param i
     * @return
     */
    public static byte[] intToByteArray(int i) {
        byte[] result = new byte[4];
        //由高位到低位
        result[0] = (byte)((i >> 24) & 0xFF);
        result[1] = (byte)((i >> 16) & 0xFF); //如果查过128 那么会被java自动转成负数
        result[2] = (byte)((i >> 8) & 0xFF);
        result[3] = (byte)(i & 0xFF);
        return result;
    }

    /**
     * 4个字节的byte[]转int
     * @param
     * @return
     */
    public static Integer byteArrayToInt(byte[] in) {
        byte[] bytes = new byte[4];

        //如果传进来数组不满足4个字节,自动填充
        if(in.length>4){
            return null;
        }else if(in.length!=4){
            Stack<Byte> st = new Stack<Byte>();
            int c = 4-in.length;
            in = invert(in);
            for(int i=0;i<in.length;i++){
                st.push(in[i]);
            }
            for(int i=0;i<c;i++){
                st.push(Byte.valueOf((byte) 0));
            }
            for(int i=0;i<4;i++){
                bytes[i] = st.pop();
            }
        }else {
            bytes = in;
        }

        int value=0;
        //由高位到低位
        for(int i = 0; i < 4; i++) {
            int shift= (4-1-i) * 8;
            value +=(bytes[i] & 0x000000FF) << shift;//往高位游
        }
        return value;
    }

    public static Integer byteToUSInt(byte bytes) {
        int value=0;
        value +=(bytes & 0xFF);
        return value;
    }
    public static Integer byteToSInt(byte bytes) {
        return Byte.valueOf(bytes).intValue();
    }

    public static byte[] invert(byte[] a){
        byte[] b = new byte[a.length];
        Stack<Byte> st = new Stack<Byte>();
        for(int i=0;i<a.length;i++){
            st.push(a[i]);
        }
        for(int i=0;i<a.length;i++){
            b[i] = st.pop();
        }
        return b;
    }

}
